#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>

main(char argc, char **argv)
{
  FILE *textf, *idxfile;
  int idx=0, c, oc=2;

  if (argc < 3)
    {
      fprintf(stderr, "usage: test2 <textfile> <idxfile>\n");
      exit(1);
    }

  textf = fopen(argv[1], "rb");
  idxfile = fopen(argv[2], "wb");

  while ((c = fgetc(textf)) != EOF)
    {
      if (oc && isgraph((unsigned char)c))
	{
	  if (oc > 1)
	    fwrite(&idx, 1, sizeof(int), idxfile);
	  oc = 0;
	}
      if (c == '\n')
	oc ++;
      idx++;
    }
  fclose(idxfile);
  fclose (textf);

  textf = fopen(argv[1], "rb");
  idxfile = fopen(argv[2], "rb");

  struct stat s;
  fstat (fileno (idxfile), &s);
  int nsections = s.st_size / sizeof(int);

  static int tmplen = 100;
  static char *tmp = (char *)malloc(tmplen);

  for (int s=0; s<nsections; s++)
    {
      int span[2];
      printf("[section %d]\n", s);
      fseek (idxfile, s * sizeof(int), 0);
      fread (span, 2, sizeof(int), idxfile);

      idx = span[0];
      fseek (textf, idx, 0);

      oc = 0;
      while (idx<span[1])
	{
	  int l=0;
	  fscanf(textf, "%s %n", tmp, &l);
	  idx += l;

	  printf("%s", tmp);
	}
      printf("\n");
    }

  return 0;
}
